/*
 * $Id$
 *
 * Copyright (c) 1998-2002 Yoon Kyung Koo(yoonforh@yahoo.com). All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL YOON KYUNG KOO OR THE OTHER
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


import java.io.*;
import java.util.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 * just dump upload request to a file 
 *
 * @version  $Revision$<br>
 *           created at 2002-06-19 17:18:53
 * @author   Yoon Kyung Koo
 */

public class UploadTestServlet extends HttpServlet {
    public void service (ServletRequest request, ServletResponse response)
	throws ServletException, IOException {
        final int BUFFER_SIZE = 8192;
        FileOutputStream fout = new FileOutputStream("/tmp/upload.result");
        try {
            int contentLength = request.getContentLength();
	    fout.write(("content length = " + contentLength + "\n").getBytes());
            // RFC 1867
            String contentType = request.getContentType();
	    fout.write(("content type = " + contentType + "\n").getBytes());
            int ind = contentType.indexOf("boundary=");
            String boundary = contentType.substring(ind + 9);

            String boundaryString = "--" + boundary;
	    fout.write(("boundary = [" + boundaryString + "]\n").getBytes());
            ServletInputStream in = request.getInputStream();
            byte[] buffer = new byte[BUFFER_SIZE];

	    while (true) {
		int result = in.readLine(buffer, 0, BUFFER_SIZE);
                if (result <= 0) {
		    break;
                }
                fout.write(buffer, 0, result);
	    }
        } catch (IOException e) {
	    fout.write(("IO exception - " + e + "\n").getBytes());
        } finally {
	    fout.close();
        }
    }
}
